// precalculate 1/3 and 2/3 steps
// calculate once at compile time so it does'nt kill performance
// assuming that these compiler macros get calculated during compile time and 
// therefore replace the macro with a constant rather than the calculation itself 

// FWD move
// forward hip
#define FWDoneThirdFH (FhipFWD - (FhipFWD-FhipREV)*1/3)
#define FWDtwoThirdFH (FhipFWD - (FhipFWD-FhipREV)*2/3)
// rear hip
#define FWDoneThirdRH (RhipFWD - (RhipFWD-RhipREV)*1/3)
#define FWDtwoThirdRH (RhipFWD - (RhipFWD-RhipREV)*2/3)

// REV move
// forward hip
#define REVoneThirdFH (FhipREV - (FhipREV-FhipFWD)*1/3)
#define REVtwoThirdFH (FhipREV - (FhipREV-FhipFWD)*2/3)
// rear hip
#define REVoneThirdRH (RhipREV - (RhipREV-RhipFWD)*1/3)
#define REVtwoThirdRH (RhipREV - (RhipREV-RhipFWD)*2/3)

// crab move left = crab FWD
#define crabFWDoneThirdFL (FLhipCrabFWD - (FLhipCrabFWD-FLhipCrabREV)*1/3)
#define crabFWDtwoThirdFL (FLhipCrabFWD - (FLhipCrabFWD-FLhipCrabREV)*2/3)
#define crabFWDoneThirdFR (FRhipCrabFWD - (FRhipCrabFWD-FRhipCrabREV)*1/3)
#define crabFWDtwoThirdFR (FRhipCrabFWD - (FRhipCrabFWD-FRhipCrabREV)*2/3)
#define crabFWDoneThirdRL (RLhipCrabFWD - (RLhipCrabFWD-RLhipCrabREV)*1/3)
#define crabFWDtwoThirdRL (RLhipCrabFWD - (RLhipCrabFWD-RLhipCrabREV)*2/3)
#define crabFWDoneThirdRR (RRhipCrabFWD - (RRhipCrabFWD-RRhipCrabREV)*1/3)
#define crabFWDtwoThirdRR (RRhipCrabFWD - (RRhipCrabFWD-RRhipCrabREV)*2/3)

// crab move right = crab REV
#define crabREVoneThirdFL (FLhipCrabREV - (FLhipCrabREV-FLhipCrabFWD)*1/3)
#define crabREVtwoThirdFL (FLhipCrabREV - (FLhipCrabREV-FLhipCrabFWD)*2/3)
#define crabREVoneThirdFR (FRhipCrabREV - (FRhipCrabREV-FRhipCrabFWD)*1/3)
#define crabREVtwoThirdFR (FRhipCrabREV - (FRhipCrabREV-FRhipCrabFWD)*2/3)
#define crabREVoneThirdRL (RLhipCrabREV - (RLhipCrabREV-RLhipCrabFWD)*1/3)
#define crabREVtwoThirdRL (RLhipCrabREV - (RLhipCrabREV-RLhipCrabFWD)*2/3)
#define crabREVoneThirdRR (RRhipCrabREV - (RRhipCrabREV-RRhipCrabFWD)*1/3)
#define crabREVtwoThirdRR (RRhipCrabREV - (RRhipCrabREV-RRhipCrabFWD)*2/3)


void forward4Beat(int stepWait, int moveDelay){
	// 4 Beat Walking
	
	// LEG	BEAT 1		BEAT 2		BEAT 3		BEAT 4
	// FR	DOWN		UP			DOWN		DOWN
	//		FULL REV	FULL FWD	1/3 REV		2/3 REV
	// RR	UP			DOWN		DOWN		DOWN
	//		FULL FWD	1/3 REV		2/3 REV		FULL REV
	// FL	DOWN		DOWN		DOWN		UP
	//		1/3 REV		2/3 REV		FULL REV	FULL FWD
	// RL	DOWN		DOWN		UP			DOWN
	//		2/3 REV		FULL REV	FULL FWD	1/3 REV
	
	if(obstacleFound(threshold)) escape();
	
	// Beat 1
	Serial.println("Forward B1");
	moveServo(HFR, idHFR, FhipREV, moveDelay);
	delay(stepWait);
	moveServo(KRR, idKRR, FLG, moveDelay);
	moveServo(HRR, idHRR, RhipFWD, moveDelay);
	moveServo(KRR, idKRR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FWDoneThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, FWDtwoThirdRH, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	
	//Beat 2
	Serial.println("Forward B2");
	moveServo(KFR, idKFR, FLG, moveDelay);
	moveServo(HFR, idHFR, FhipFWD, moveDelay);
	moveServo(KFR, idKFR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, FWDoneThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FWDtwoThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, RhipREV, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 3
	Serial.println("Forward B3");
	moveServo(HFR, idHFR, FWDoneThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, FWDtwoThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FhipREV, moveDelay);
	delay(stepWait);
	moveServo(KRL, idKRL, FLG, moveDelay);
	moveServo(HRL, idHRL, RhipFWD, moveDelay);
	moveServo(KRL, idKRL, FTG, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 4
	Serial.println("Forward B4");
	moveServo(HFR, idHFR, FWDtwoThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, RhipREV, moveDelay);
	delay(stepWait);
	moveServo(KFL, idKFL, FLG, moveDelay);
	moveServo(HFL, idHFL, FhipFWD, moveDelay);
	moveServo(KFL, idKFL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, FWDoneThirdRH, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
}
void reverse4Beat(int stepWait, int moveDelay){
	// 4 Beat Walking
	// just mirror the forward4Beat
	// and switch FWD for REV and vice versa
	
	// Beat 1
	Serial.println("Reverse B1");
	moveServo(HRL, idHRL, RhipFWD, moveDelay);
	delay(stepWait);
	moveServo(KFL, idKFL, FLG, moveDelay);
	moveServo(HFL, idHFL, FhipREV, moveDelay);
	moveServo(KFL, idKFL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, REVoneThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, REVtwoThirdFH, moveDelay);
	delay(stepWait);
	
	//Beat 2
	Serial.println("Reverse B2");
	moveServo(KRL, idKRL, FLG, moveDelay);
	moveServo(HRL, idHRL, RhipREV, moveDelay);
	moveServo(KRL, idKRL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, REVoneThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, REVtwoThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, FhipFWD, moveDelay);
	delay(stepWait);

	//Beat 3
	Serial.println("Reverse B3");
	moveServo(HRL, idHRL, REVoneThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, REVtwoThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, RhipFWD, moveDelay);
	delay(stepWait);
	moveServo(KFR, idKFR, FLG, moveDelay);
	moveServo(HFR, idHFR, FhipREV, moveDelay);
	moveServo(KFR, idKFR, FTG, moveDelay);
	delay(stepWait);

	//Beat 4
	Serial.println("Reverse B4");
	moveServo(HRL, idHRL, REVtwoThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FhipFWD, moveDelay);
	delay(stepWait);
	moveServo(KRR, idKRR, FLG, moveDelay);
	moveServo(HRR, idHRR, RhipREV, moveDelay);
	moveServo(KRR, idKRR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, REVoneThirdFH, moveDelay);
	delay(stepWait);
}

void turnRight4Beat(int stepWait, int moveDelay){
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 1
	Serial.println("turn right B1");
	moveServo(HRL, idHRL, FWDtwoThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FWDoneThirdFH, moveDelay);
	delay(stepWait);
	moveServo(KRR, idKRR, FLG, moveDelay);
	moveServo(HRR, idHRR, RhipREV, moveDelay);
	moveServo(KRR, idKRR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, FhipFWD, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 2
	Serial.println("turn right B2");
	moveServo(HRL, idHRL, RhipREV, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FWDtwoThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, REVoneThirdRH, moveDelay);
	delay(stepWait);
	moveServo(KFR, idKFR, FLG, moveDelay);
	moveServo(HFR, idHFR, FhipREV, moveDelay);
	moveServo(KFR, idKFR, FTG, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 3
	Serial.println("turn right B3");
	moveServo(KRL, idKRL, FLG, moveDelay);
	moveServo(HRL, idHRL, RhipFWD, moveDelay);
	moveServo(KRL, idKRL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FhipREV, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, REVtwoThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, REVoneThirdFH, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 4
	Serial.println("turn right B4");
	moveServo(HRL, idHRL, FWDoneThirdRH, moveDelay);
	delay(stepWait);
	moveServo(KFL, idKFL, FLG, moveDelay);
	moveServo(HFL, idHFL, FhipFWD, moveDelay);
	moveServo(KFL, idKFL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, RhipFWD, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, REVtwoThirdFH, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
}
void turnLeft4Beat(int stepWait, int moveDelay){
	
	if(obstacleFound(threshold)) escape();

	//Beat 1
	Serial.println("turn left B1");
	moveServo(HFR, idHFR, FhipREV, moveDelay);
	delay(stepWait);
	moveServo(KRR, idKRR, FLG, moveDelay);
	moveServo(HRR, idHRR, RhipFWD, moveDelay);
	moveServo(KRR, idKRR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, REVoneThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, REVtwoThirdFH, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 2
	Serial.println("turn left B2");
	moveServo(KFR, idKFR, FLG, moveDelay);
	moveServo(HFR, idHFR, FhipFWD, moveDelay);
	moveServo(KFR, idKFR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, FWDoneThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, REVtwoThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, RhipFWD, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 3
	Serial.println("turn left B3");
	moveServo(HFR, idHFR, FWDoneThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, FWDtwoThirdRH, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FhipFWD, moveDelay);
	delay(stepWait);
	moveServo(KRL, idKRL, FLG, moveDelay);
	moveServo(HRL, idHRL, RhipREV, moveDelay);
	moveServo(KRL, idKRL, FTG, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 4
	Serial.println("turn left B4");
	moveServo(HFR, idHFR, FWDtwoThirdFH, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, RhipREV, moveDelay);
	delay(stepWait);
	moveServo(KFL, idKFL, FLG, moveDelay);
	moveServo(HFL, idHFL, FhipREV, moveDelay);
	moveServo(KFL, idKFL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, REVoneThirdRH, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
}

void crabLeft4Beat(int stepWait, int moveDelay){
	// 4 Beat Walking
	
	// LEG	BEAT 1		BEAT 2		BEAT 3		BEAT 4
	// FL	DOWN		UP			DOWN		DOWN
	//		FULL REV	FULL FWD	1/3 REV		2/3 REV
	// FR	UP			DOWN		DOWN		DOWN
	//		FULL FWD	1/3 REV		2/3 REV		FULL REV
	// RL	DOWN		DOWN		DOWN		UP
	//		1/3 REV		2/3 REV		FULL REV	FULL FWD
	// RR	DOWN		DOWN		UP			DOWN
	//		2/3 REV		FULL REV	FULL FWD	1/3 REV
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 1
	Serial.println("CrabLeft B1");
	moveServo(HFL, idHFL, FLhipCrabREV, moveDelay);
	delay(stepWait);
	moveServo(KFR, idKFR, FLG, moveDelay);
	moveServo(HFR, idHFR, FRhipCrabFWD, moveDelay);
	moveServo(KFR, idKFR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, crabFWDoneThirdRL, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, crabFWDtwoThirdRR, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 2
	Serial.println("CrabLeft B2");
	moveServo(KFL, idKFL, FLG, moveDelay);
	moveServo(HFL, idHFL, FLhipCrabFWD, moveDelay);
	moveServo(KFL, idKFL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, crabFWDoneThirdFR, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, crabFWDtwoThirdRL, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, RRhipCrabREV, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 3
	Serial.println("CrabLeft B3");
	moveServo(HFL, idHFL, crabFWDoneThirdFL, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, crabFWDtwoThirdFR, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, RLhipCrabREV, moveDelay);
	delay(stepWait);
	moveServo(KRR, idKRR, FLG, moveDelay);
	moveServo(HRR, idHRR, RRhipCrabFWD, moveDelay);
	moveServo(KRR, idKRR, FTG, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 4
	Serial.println("CrabLeft B4");
	moveServo(HFL, idHFL, crabFWDtwoThirdFL, moveDelay);
	delay(stepWait);
	moveServo(HFR, idHFR, FRhipCrabREV, moveDelay);
	delay(stepWait);
	moveServo(KRL, idKRL, FLG, moveDelay);
	moveServo(HRL, idHRL, RLhipCrabFWD, moveDelay);
	moveServo(KRL, idKRL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, crabFWDoneThirdRR, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
}
void crabRight4Beat(int stepWait, int moveDelay){
	// 4 Beat Walking

	if(obstacleFound(threshold)) escape();
	
	//Beat 1
	Serial.println("CrabRight B1");
	moveServo(HFR, idHFR, FRhipCrabFWD, moveDelay);
	delay(stepWait);
	moveServo(KFL, idKFL, FLG, moveDelay);
	moveServo(HFL, idHFL, FLhipCrabREV, moveDelay);
	moveServo(KFL, idKFL, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, crabREVoneThirdRR, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, crabREVtwoThirdRL, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 2
	Serial.println("CrabRight B2");
	moveServo(KFR, idKFR, FLG, moveDelay);
	moveServo(HFR, idHFR, FRhipCrabREV, moveDelay);
	moveServo(KFR, idKFR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, crabREVoneThirdFL, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, crabREVtwoThirdRR, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, RLhipCrabFWD, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 3
	Serial.println("CrabRight B3");
	moveServo(HFR, idHFR, crabREVoneThirdFR, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, crabREVtwoThirdFL, moveDelay);
	delay(stepWait);
	moveServo(HRR, idHRR, RRhipCrabFWD, moveDelay);
	delay(stepWait);
	moveServo(KRL, idKRL, FLG, moveDelay);
	moveServo(HRL, idHRL, RLhipCrabREV, moveDelay);
	moveServo(KRL, idKRL, FTG, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
	
	//Beat 4
	Serial.println("CrabRight B4");
	moveServo(HFR, idHFR, crabREVtwoThirdFR, moveDelay);
	delay(stepWait);
	moveServo(HFL, idHFL, FLhipCrabFWD, moveDelay);
	delay(stepWait);
	moveServo(KRR, idKRR, FLG, moveDelay);
	moveServo(HRR, idHRR, RRhipCrabREV, moveDelay);
	moveServo(KRR, idKRR, FTG, moveDelay);
	delay(stepWait);
	moveServo(HRL, idHRL, crabREVoneThirdRL, moveDelay);
	delay(stepWait);
	
	if(obstacleFound(threshold)) escape();
}

void winkRight(int times, int moveDelay){
	
	moveServo(KRR, idKRR, 70, moveDelay);
	moveServo(KRL, idKRL, 20, moveDelay);
	moveServo(KFR, idKFR, 70, moveDelay);
	
	moveServo(HFL, idHFL, FhipFWD, moveDelay);
	moveServo(HRL, idHRL, RhipREV, moveDelay);
	moveServo(HRR, idHRR, RhipFWD, moveDelay);
	moveServo(HFR, idHFR, FWDtwoThirdFH, moveDelay);
	for (int i = 0; i < times; i++){
		moveServo(KFR, idKFR, -30, moveDelay*5);
		delay(100);
		moveServo(KFR, idKFR, 0, moveDelay*5);
		delay(100);
	}
	moveServo(KFR, idKFR, FTG, moveDelay);
}

// old turn sub routine

//void bodyTurnLeft(int stepWait, int moveDelay){
	//
	//Serial.println("turning .. left");
	//// move all hips
	//moveServo(HFR, idHFR, bodyTurnStart, moveDelay);
	//moveServo(HRR, idHRR, -bodyTurnStart, moveDelay);
	//moveServo(HFL, idHFL, bodyTurnStart, moveDelay);
	//moveServo(HRL, idHRL, -bodyTurnStart, moveDelay);
	//delay(stepWait);
//
	////lift each leg and put back in start position
	//// front right leg
	//moveServo(KFR, idKFR, FLG, moveDelay);
	//moveServo(HFR, idHFR, bodyTurnStart + bodyTurnDiff, moveDelay);
	//moveServo(KFR, idKFR, FTG, moveDelay);
	//delay(stepWait);
	//
	//// front left leg
	//moveServo(KFL, idKFL, FLG, moveDelay);
	//moveServo(HFL, idHFL, bodyTurnStart - bodyTurnDiff, moveDelay);
	//moveServo(KFL, idKFL, FTG, moveDelay);
	//delay(stepWait);
//
	//// rear right leg
	//moveServo(KRR, idKRR, FLG, moveDelay);
	//moveServo(HRR, idHRR, -bodyTurnStart + bodyTurnDiff, moveDelay);
	//moveServo(KRR, idKRR, FTG, moveDelay);
	//delay(stepWait);
//
	//// rear left leg
	//moveServo(KRL, idKRL, FLG, moveDelay);
	//moveServo(HRL, idHRL, -bodyTurnStart - bodyTurnDiff, moveDelay);
	//moveServo(KRL, idKRL, FTG, moveDelay);
	//delay(stepWait);
//}
//
//void bodyTurnRight(int stepWait, int moveDelay){
	//
	//Serial.println("turning .. right");
	//
	//// move all hips
	//moveServo(HFR, idHFR, bodyTurnStart, moveDelay);
	//moveServo(HRR, idHRR, -bodyTurnStart, moveDelay);
	//moveServo(HFL, idHFL, bodyTurnStart, moveDelay);
	//moveServo(HRL, idHRL, -bodyTurnStart, moveDelay);
	//delay(stepWait);
	//
	////lift each leg and put back in start position
	//// front right leg
	//moveServo(KFR, idKFR, FLG, moveDelay);
	//moveServo(HFR, idHFR, bodyTurnStart - bodyTurnDiff, moveDelay);
	//moveServo(KFR, idKFR, FTG, moveDelay);
	//delay(stepWait);
	//
	//// front left leg
	//moveServo(KFL, idKFL, FLG, moveDelay);
	//moveServo(HFL, idHFL, bodyTurnStart + bodyTurnDiff, moveDelay);
	//moveServo(KFL, idKFL, FTG, moveDelay);
	//delay(stepWait);
	//
	//// rear right leg
	//moveServo(KRR, idKRR, FLG, moveDelay);
	//moveServo(HRR, idHRR, -bodyTurnStart - bodyTurnDiff, moveDelay);
	//moveServo(KRR, idKRR, FTG, moveDelay);
	//delay(stepWait);
	//
	////rear left leg
	//moveServo(KRL, idKRL, FLG, moveDelay);
	//moveServo(HRL, idHRL, -bodyTurnStart + bodyTurnDiff, moveDelay);
	//moveServo(KRL, idKRL, FTG, moveDelay);
	//delay(stepWait);
//}
//