
// move the servo with a for loop
// so even if values jump numbers from step to step
// the servos wont jerk into position but rather move there normally
void moveServo(Servo s, int servoID, int angle, int wait){
	
	int mappedAngle = mapServo(servoID, angle);
	int servoPosNow = s.read();
	
	//Serial.print(";servo");
	//Serial.print(servoID);
	//Serial.print(";");
	//Serial.print(angle);
	//Serial.print(";");
	//Serial.print(s.read());
	//Serial.print(";");
	//Serial.print(mappedAngle);
	
		if (servoPosNow > mappedAngle){
			//Serial.print(";-");
			for (int i = s.read(); i > mappedAngle; i--){
				s.write(i);
				delay(wait);
			}
		}else{
			//Serial.print(";+");
			for (int i = servoPosNow; i < mappedAngle; i++){
				s.write(i);
				delay(wait);
			}
		}
	//Serial.println("");
}

void moveServoFAST(Servo s, int servoID, int angle){
	s.write(mapServo(servoID, angle));
	delay(5);
}

// get the real servo values for a given angle in the robots coordinate system 
int mapServo(int servoID, int angle){
	switch (servoID){
		case idHFR:
			return map(angle, 0, 90, HFR_deg0, HFR_deg90);
			break;
		case idHRR:
			return map(angle, 0, -90, HRR_deg0, HRR_deg90);
			break;
		case idHFL:
			return map(angle, 0, 90, HFL_deg0, HFL_deg90);
			break;
		case idHRL:
			return map(angle, 0, -90, HRL_deg0, HRL_deg90);
			break;
		case idKFR:
			return map(angle, 0, 90, KFR_deg0, KFR_deg90);
			break;
		case idKFL:
			return map(angle, 0, 90, KFL_deg0, KFL_deg90);
			break;
		case idKRR:
			return map(angle, 0, 90, KRR_deg0, KRR_deg90);
			break;
		case idKRL:
			return map(angle, 0, 90, KRL_deg0, KRL_deg90);
			break;
		case idEYE:
			return map(angle, 0, EYE_max - EYE_min, EYE_min, EYE_max);
			break;
	}
}

	